#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Bresenham Line 3", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    // line coordinates
    int x0 = 0;
    int y0 = 0;
    int x1 = 30;
    int y1 = 10;

    float slope = (float)(y1 - y0) / (float)(x1 - x0);
    int y = y0;
    float error = 0.0;

    for (int x = x0; x <= x1; ++x)
    {
        gfx.setPixel(x, y, Color(255, 255, 255));
        error += slope;

        if (error >= 0.5)
        {
            y++;
            error -= 1.0;
        }
    }
    gfx.render();

    while (sys.isQuitRequested() == false)
    {
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
